= nng_http_handler_set_data(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_handler_set_data - set extra data for HTTP handler

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_handler_set_data(nng_http_handler *handler, void *data,
    void (*dtor)(void *));
----

== DESCRIPTION

The `nng_http_handler_set_data()` function is used to set an additional
_data_ for the _handler_.
The stored _data_ can be retrieved later in the handler function using
xref:nng_http_handler_get_data.3http.adoc[`nng_http_handler_get_data()`].

Additionally, when the handler is deallocated, if _dtor_ is not `NULL`,
then it will be called with _data_ as its argument.
The intended use of
this function is deallocate any resources associated with _data_.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory to perform the operation.
`NNG_ENOTSUP`:: No support for HTTP in the library.

== SEE ALSO

[.text-left]
xref:nng_http_handler_alloc.3http.adoc[nng_http_handler_alloc(3http)],
xref:nng_http_handler_get_data.3http.adoc[nng_http_server_get_data(3http)],
xref:nng_http_server_add_handler.3http.adoc[nng_http_server_add_handler(3http)],
xref:nng.7.adoc[nng(7)]
